package org.greenstone.gsdl3.gs3build.indexers;

import org.greenstone.gsdl3.gs3build.doctypes.DocumentID;
import org.greenstone.gsdl3.gs3build.doctypes.DocumentInterface;

public interface IndexerInterface
{
  public static final String DOCUMENT_LEVEL = "document";
  public static final String SECTION_LEVEL = "section";
  public static final String PARAGRAPH_LEVEL = "paragraph";

  public static final String GS2_INDEX_LABEL = "Index";  

  public String  getIndexType();
  public String  getName();
  public int     getNumberOfPasses();
  // TODO: add a function call to provide appropriate XML for the service description
    public boolean addServiceDescriptions(org.w3c.dom.Element service_rack_list);
  public void    tidyup();

  public boolean configure(String label, String value);
  public boolean configure(org.w3c.dom.Node node);
  public boolean addIndex(String name, String level, String field);

  public boolean startPass(int passNumber);
  public boolean indexDocument(DocumentID id, DocumentInterface document);
  public boolean endPass(int passNumber);

}
